// Ex12.java

package ch.aplu.tut;

import ch.aplu.android.*;
import java.util.*;
import android.graphics.*;

public class Ex12 extends GameGrid implements GGMultiTouchListener
{
  private GGBackground bg;
  private HashMap<Integer, Point> circles = 
    new HashMap<Integer, Point>();

  public Ex12()
  {
    super(true, null);
  }

  public void main()
  {
    bg = getBg();
    bg.drawFrame(WHITE);
    bg.setPaintColor(GREEN);
    addMultiTouchListener(this,
      GGMultiTouch.press
      | GGMultiTouch.pointerPress
      | GGMultiTouch.release
      | GGMultiTouch.pointerRelease
      | GGMultiTouch.drag);
    refresh();
  }

  public boolean multiTouchEvent(GGMultiTouch multiTouch)
  {
    int x = multiTouch.getX();
    int y = multiTouch.getY();
    int pointerId = multiTouch.getPointerId();
    switch (multiTouch.getEvent())
    {
      case GGMultiTouch.press:
      case GGMultiTouch.pointerPress:
        circles.put(pointerId, new Point(x, y));
        for (Point p : circles.values())
          bg.fillCircle(p, 50);
        break;

      case GGMultiTouch.release:
        bg.clear();
        circles.clear();
        break;

      case GGMultiTouch.pointerRelease:
        bg.clear();
        circles.remove(pointerId);
        for (Point p : circles.values())
          bg.fillCircle(p, 50);
        break;
      
      case GGMultiTouch.drag:
        bg.clear();
        circles.remove(pointerId);
        circles.put(pointerId, new Point(x, y));
        for (Point p : circles.values())
          bg.fillCircle(p, 50);
        break;
    }
    bg.drawFrame(WHITE);
    refresh();
    return true;
  }
}
