// Ex14a.java
// Rubber band rectangle, two fingers

package ch.aplu.tut;

import ch.aplu.android.*;

public class Ex14a extends GameGrid implements GGMultiTouchListener
{
  private int xStart;
  private int yStart;
  private int xEnd;
  private int yEnd;
  private boolean isRectangleDragging;

  public Ex14a()
  {
    super("reef", windowZoom(500));
  }

  public void main()
  {
    addMultiTouchListener(this,
      GGMultiTouch.press
      | GGMultiTouch.pointerPress
      | GGMultiTouch.pointerRelease
      | GGMultiTouch.drag);
    getBg().setPaintColor(YELLOW);
    getBg().setLineWidth(4);
  }

  public boolean multiTouchEvent(GGMultiTouch multiTouch)
  {
    int x = multiTouch.getX();
    int y = multiTouch.getY();
    int pointerId = multiTouch.getPointerId();

    switch (multiTouch.getEvent())
    {
      case GGMultiTouch.press:  // first finger
        xStart = xEnd = x;
        yStart = yEnd = y;
        getBg().setXORMode();
        isRectangleDragging = false;
        break;

      case GGMultiTouch.pointerPress:
        if (pointerId == 1)  // Second finger
        {
          isRectangleDragging = true;
          xEnd = x;
          yEnd = y;
          getBg().drawRectangle(xStart, yStart, xEnd, yEnd);
        }
        break;

      case GGMultiTouch.drag:  // any finger
        if (!isRectangleDragging || pointerId > 1)
          break;
        getBg().drawRectangle(xStart, yStart, xEnd, yEnd);
        if (pointerId == 0)
        {
          xStart = x;
          yStart = y;
        }
        if (pointerId == 1)
        {
          xEnd = x;
          yEnd = y;
        }
        getBg().drawRectangle(xStart, yStart, xEnd, yEnd);
        break;

      case GGMultiTouch.pointerRelease:  // any finger
        if (!isRectangleDragging || pointerId > 1)
          break;
        isRectangleDragging = false;
        getBg().setPaintMode();
        getBg().drawRectangle(xStart, yStart, xEnd, yEnd);
        break;
    }
    refresh();
    return true;
  }
}
