// Ex15.java
// Image crop

package ch.aplu.tut;

import android.graphics.Color;
import android.graphics.Point;
import ch.aplu.android.*;

public class Ex15a extends GameGrid implements GGTouchListener
{
  private int xStart;
  private int yStart;
  private int xEnd;
  private int yEnd;

  public Ex15a()
  {
    super("reef", windowZoom(500));
  }

  public void main()
  {
    refresh();
    addTouchListener(this, GGTouch.press | GGTouch.drag | GGTouch.release);
    getBg().setXORMode();
    getBg().setPaintColor(YELLOW);
    getBg().setLineWidth(4);
  }
  
  public boolean touchEvent(GGTouch touch)
  {
    if (touch.getEvent() == GGTouch.press)
    {
      xStart = xEnd = touch.getX();
      yStart = yEnd = touch.getY();
    }
    if (touch.getEvent() == GGTouch.drag)
    {
      getBg().drawRectangle(
        new Point(xStart, yStart), new Point(xEnd, yEnd), 1, true);
      xEnd = touch.getX();
      yEnd = touch.getY();
      getBg().drawRectangle(
        new Point(xStart, yStart), new Point(xEnd, yEnd), 1, true);
      refresh();
    }
    if (touch.getEvent() == GGTouch.release)
    {
      xEnd = touch.getX();
      yEnd = touch.getY();
      Point pt = getBg().drawRectangle(
        new Point(xStart, yStart), new Point(xEnd, yEnd), 1, true);

      int width = Math.abs(pt.x - xStart);
      int height = Math.abs(pt.y - yStart);
      if (width < 20 || height < 20)
        return true;
      GGBitmap bm = new GGBitmap(width, height);
      bm.drawImage(GGBitmap.crop(getBg().getBgImage(), 
        xStart, yStart, pt.x, pt.y), 0, 0);
      bm.setLineWidth(4);
      bm.setPaintColor(Color.YELLOW);
      bm.drawRectangle(new Point(0, 0), new Point(width, height));
      removeAllActors();
      addActorNoRefresh(new Actor(bm.getBitmap()), 
        new Location(width / 2, height / 2));
      refresh();
    }
    return true;
  }
}
