// SetDiscoverability.java
// A maximum of 300 s is allowed (device dependent)

package ch.aplu.btex;

import ch.aplu.android.*;
import ch.aplu.android.bluetooth.*;
import android.bluetooth.*;

public class SetDiscoverability extends GameGrid
{
  private GGConsole c;

  public void main()
  {
    c = GGConsole.init();
    BluetoothAdapter adapter =
      BluetoothDiscovery.getBluetoothAdapter(this);
    if (adapter == null)
    {
      c.println("Bluetooth not supported");  // e.g. in emulator
      return;
    }
    c.println("Testing if Bluetooth is enabled...");
    if (!adapter.isEnabled())
    {
      requestBluetoothEnable();
      if (adapter.isEnabled())
        c.println("Enabled.");
      else
      {
        c.println("Not enabled.");
        return;
      }
    }

    c.println("Trying to set discoverability for 200 s...");
    int rc = requestBluetoothDiscoverability(200);
    if (rc == 0)
      c.println("Discoverability unchanged");
    else
      c.println("Discoverable for " + rc + " s");
  }

}
