// CardEx02.java
// Transfer card

package ch.aplu.cardex02;

import android.graphics.Color;
import ch.aplu.jcardgame.*;
import ch.aplu.android.*;

public class CardEx02 extends CardGame
{
  public enum Suit
  {
    SPADES, HEARTS, DIAMONDS, CLUBS
  }

  public enum Rank
  {
    ACE, KING, QUEEN, JACK, TEN, NINE, EIGHT, SEVEN, SIX
  }

  private Deck deck;
  
  public CardEx02()
  {
    super(Color.rgb(20, 80, 0), Color.WHITE, BoardType.HORZ_SQUARE, windowZoom(600)); 
  }
  
  public void main()
  {
    showToast("Press long on hand to move card");
    deck = new Deck(Suit.values(), Rank.values(), "cover");
    Hand[] hands = deck.dealingOut(1, 9);
    final Hand stock = hands[1];
    stock.setView(this, new StackLayout(new Location(300, 150)));
    stock.draw();

    hands[0].setView(this, new RowLayout(new Location(300, 400), 500));
    hands[0].sort(Hand.SortType.SUITPRIORITY, false);
    hands[0].draw();
    hands[0].addCardListener(new CardAdapter()
    {
      public void longPressed(Card card)
      {
        card.transfer(stock, true);
      }
    });
    hands[0].setTouchEnabled(true);
  }
 
}