// CardEx11a.java
// Extracting mixed sequences

package ch.aplu.cardex11a;

import ch.aplu.jcardgame.*;
import ch.aplu.android.*;
import ch.aplu.util.Monitor;
import android.graphics.Color;

public class CardEx11a extends CardGame implements GGTouchListener
{
  public enum Suit
  {
    SPADES, HEARTS, DIAMONDS, CLUBS
  }

  public enum Rank
  {
    ACE, KING, QUEEN, JACK, TEN, NINE, EIGHT, SEVEN, SIX, FIVE, FOUR, THREE, TWO
  }
 
  private Deck deck;

  public CardEx11a()
  {
    super(Color.rgb(20, 80, 0), Color.WHITE, BoardType.HORZ_FULL, windowZoom(900)); 
  }

  public void main()
  {
    deck = new Deck(Suit.values(), Rank.values(), "cover");
    addTouchListener(this, GGTouch.press);
    while (true)
    {
      Hand hand = deck.dealingOut(1, 15)[0];
      RowLayout layout = new RowLayout(new Location(50, 80), 1500);
      layout.setCardAlignment(Hand.CardAlignment.FIRST);
      hand.setView(this, layout);
      hand.sort(Hand.SortType.RANKPRIORITY, true);

      Hand[] sequence3 = hand.extractSequences(3);
      for (int i = 0; i < sequence3.length; i++)
      {
        sequence3[i].
          setView(this, new RowLayout(new Location(70 + 150 * i, 230), 120));
        sequence3[i].draw();
      }

      Hand[] sequence4 = hand.extractSequences(4);
      for (int i = 0; i < sequence4.length; i++)
      {
        sequence4[i].
          setView(this, new RowLayout(new Location(70 + 150 * i, 380), 120));
        sequence4[i].draw();
      }

      Hand[] sequence5 = hand.extractSequences(5);
      for (int i = 0; i < sequence5.length; i++)
      {
        sequence5[i].
          setView(this, new RowLayout(new Location(100 + 200 * i, 530), 150));
        sequence5[i].draw();
      }

      showToast("Click to generate the next card set.");
      Monitor.putSleep();
      // Cleanup all hands
      hand.removeAll(false);
      for (Hand h : sequence3)
        h.removeAll(false);
      for (Hand h : sequence4)
        h.removeAll(false);
      for (Hand h : sequence5)
        h.removeAll(false);
    }
  }

  public boolean touchEvent(GGTouch touch)
  {
    Monitor.wakeUp();
    return true;
  }

}