// BlackKey.java

package ch.aplu.clavier;

import ch.aplu.android.*;
 
public class BlackKey extends Actor
{
  // octave number, note name, x for #
  private final static String[] blackNotes =
  {
    "2cx", "2dx", "", "2fx", "2gx", "2ax", "",
    "3cx", "3dx", "", "3fx", "3gx", "3ax", "",
    ""
  };
  private final static String sound = "p";  // Piano
  private int index;

  public BlackKey(int index)
  {
    super(blackNotes[index].equals("") ? "transparent" : "black_key");
    this.index = index;
  }

  public void play()
  {
    if (!blackNotes[index].equals(""))
       gameGrid.playSound(sound + blackNotes[index], false);
  }
  
  public boolean exists()
  {
    return !blackNotes[index].equals("");
  }
}
