// Clavier.java

package ch.aplu.clavier;

import android.graphics.Point;
import ch.aplu.android.*;

public class Clavier extends GameGrid
  implements GGMultiTouchListener
{
  private final int nbKeys = 15;
  private WhiteKey[] whiteKeys = new WhiteKey[nbKeys];
  private BlackKey[] blackKeys = new BlackKey[nbKeys];
  private int w;
  private int h;
  private int x0;
  private int x1;
  private int dx;
  private int y0;
  private int y1;

  public Clavier()
  {
    super(true, windowZoom(600));
    setScreenOrientation(LANDSCAPE);
  }

  public void main()
  {
    makeKeys();
    addMultiTouchListener(this,
      GGMultiTouch.press | GGMultiTouch.pointerPress);
  }

  private void makeKeys()
  {
    w = getNbHorzCells();
    h = getNbVertCells();
    x0 = w / 16;
    x1 = w / 11;
    dx = w / 16;
    y0 = h / 2;
    y1 = 205 * h / 500;

    addActorNoRefresh(new Actor("steinway_logo"), new Location(w / 2, h / 10));
    for (int i = 0; i < nbKeys; i++)
    {
      whiteKeys[i] = new WhiteKey(i);
      addActorNoRefresh(whiteKeys[i], new Location(x0 + i * dx, y0));
      blackKeys[i] = new BlackKey(i);
      addActorNoRefresh(blackKeys[i], new Location(x1 + i * dx, y1));
    }
    refresh();
  }

  public boolean multiTouchEvent(GGMultiTouch multiTouch)
  {
    int x = multiTouch.getX();
    int y = multiTouch.getY();
    int whiteIndex = (x - x0 / 2) / dx;
    int blackIndex = (x - x1 / 2) / dx;

    if (x < x0 / 2 || x > x0 / 2 + nbKeys * dx)
      return true;
    if (y < h / 4 || y > 3 * h / 4)
      return true;

    if (y < 11 * h / 20 && blackKeys[blackIndex].exists())
      blackKeys[blackIndex].play();
    else
      whiteKeys[whiteIndex].play();

    return true;
  }
}
