// LightsOut.java

package ch.aplu.lightsout;

import ch.aplu.android.*;

public class LightsOut extends GameGrid implements GGTouchListener
{
  public LightsOut()
  {
    super(5, 5, cellZoom(50));
  }

  public void main()
  {
    for (int i = 0; i < 5; i++)
    {
      for (int k = 0; k < 5; k++)
      {
        Actor actor = new Actor("lightout", 2);
        actor.show(1);
        addActor(actor, new Location(i, k));
      }
    }
    addTouchListener(this, GGTouch.click);
  }

  public boolean touchEvent(GGTouch touch)
  {
    Location loc = toLocationInGrid(touch.getX(), touch.getY());
    Location[] locs  = new Location[5];
    locs[0] = new Location(loc.x, loc.y);
    locs[1] = new Location(loc.x, loc.y - 1);
    locs[2] = new Location(loc.x, loc.y + 1);
    locs[3] = new Location(loc.x - 1, loc.y);
    locs[4] = new Location(loc.x + 1, loc.y);

    for (int i = 0; i < 5; i++)
    {
      Actor a = getOneActorAt(locs[i]);
      if (a != null)
        a.showNextSprite();
    }
    refresh();
    return true;
  }
}