// PacActor.java
// Used for PacMan

package ch.aplu.pacman;


import ch.aplu.android.*;
import android.graphics.Color;

public class PacActor extends Actor implements GGSoftButtonListener
{
  private static final int nbSprites = 4;
  private int idSprite = 0;
  private int nbPills = 0;

  public PacActor()
  {
    super(true, "pacpix", nbSprites);  // Rotatable
  }

  public void buttonPressed(int buttonNb)
  {}
  public void buttonReleased(int buttonNb)
  {}
  public void buttonClicked(int buttonNb)
  {}

  public void buttonRepeated(int buttonNb)
  {
    Location next = null;
    switch (buttonNb)
    {
      case 2:
        next = getLocation().getNeighbourLocation(Location.WEST);
        setDirection(Location.WEST);
        break;
      case 0:
        next = getLocation().getNeighbourLocation(Location.NORTH);
        setDirection(Location.NORTH);
        break;
      case 3:
        next = getLocation().getNeighbourLocation(Location.EAST);
        setDirection(Location.EAST);
        break;
      case 1:
        next = getLocation().getNeighbourLocation(Location.SOUTH);
        setDirection(Location.SOUTH);
        break;
    }
    if (next != null && canMove(next))
    {
      setLocation(next);
      eatPill(next);
    }
  }

   public void act()
  {
    if (!isVisible())
      return;
    show(idSprite);
    idSprite++;
    if (idSprite == nbSprites)
      idSprite = 0;
  }

  private boolean canMove(Location location)
  {
    int c = getBackground().getColor(location);
    if (c == Color.GRAY)
      return false;
    else
      return true;
  }

  private void eatPill(Location location)
  {
    int c = getBackground().getColor(location);
    if (c == Color.BLACK)
    {
      nbPills++;
      getBackground().fillCell(location, Color.LTGRAY);
      gameGrid.setTitle("# Eaten Pills: " + nbPills);
    }
  }

  protected int getNbPills()
  {
    return nbPills;
  }
}
