// Ball.java

package ch.aplu.shootinggallery;

import android.graphics.Point;
import ch.aplu.android.*;

class Ball extends Actor
{
  private ShootingGallery app;
  private final int speedFactor = 100;
  private int speed;
  private int value;

  public Ball(ShootingGallery app, int value)
  {
    super("ball_" + value);
    this.app = app;
    this.value = value;
    setActEnabled(false);
  }
  
  protected void launch(Location start, GGVector v)
  {
    setLocation(start);
    setDirection(Math.toDegrees(v.getDirection()));
    speed = (int)(speedFactor * v.magnitude());
    setActEnabled(true);
  }  
  
  protected int getValue()
  {
    return value;
  }

  public void act()
  {
    if (isInGrid())
     move(speed);
    else
    {  
      app.displayResult();
      removeSelf();
    }
  }

}
