// SpaceInvader.java

package ch.aplu.spaceinvader;

import ch.aplu.android.*;
import android.graphics.*;

public class SpaceInvader extends GameGrid
  implements GGTouchListener
{
  private final static int nbRows = 3;
  private final static int nbCols = 9;
  protected final static int dx = 6;
  protected final static int nbHorzCells = 81;
  protected final static int nbVertCells = 51;

  public SpaceInvader()
  {
    super(nbHorzCells, nbVertCells, cellZoom(5));
    setScreenOrientation(LANDSCAPE);
  }

  public void main()
  {
    setSimulationPeriod(50);
    getBg().drawText("Button actions:", new Point(30, 10));
    getBg().drawText("VOLUME to move spaceship", new Point(30, 40));
    getBg().drawText("MENU to shoot", new Point(30, 60));
    getBg().drawText("BACK to restart", new Point(30, 80));
    getBg().drawText("Tap the screen to start...", new Point(60, 120));
    addTouchListener(this, GGTouch.press);
    refresh();
  }

  protected void init()
  {
    getBg().clear(Color.BLACK);
    removeAllActors();
    for (int i = 0; i < nbRows; i++)
    {
      for (int k = 0; k < nbCols; k++)
      {
        Alien alien = new Alien();
        addActor(alien, new Location(nbHorzCells / 2 - (nbCols / 2) * dx + k * dx, 10 + 5 * i));
      }
    }
    SpaceShip ss = new SpaceShip(this);
    addNavigationListener(ss);
    addActor(ss, new Location(nbHorzCells / 2, 45));
    doRun();
  }
  
  public boolean touchEvent(GGTouch touch)
  {
    init();
    setTouchEnabled(false);
    return true;
  }  
}
