// SpiritLevel.java

package ch.aplu.spiritlevelbase;

import ch.aplu.android.*;
import android.graphics.*;
import android.hardware.SensorManager;

public class SpiritLevelBase extends GameGrid
{
  private int offset;
  private Actor bubble;
  private GGComboSensor sensor;
  private int rLimit;

  public SpiritLevelBase()
  {
    super("gear", windowZoom(600));
  }

  public void main()
  {
    offset = getNbVertCells() / 2;
    rLimit = getNbVertCells() / 4;
    sensor = GGComboSensor.init(this, SensorManager.SENSOR_DELAY_FASTEST);
    bubble = new Actor("bubble");
    addActor(bubble, new Location(offset, offset));
    setSimulationPeriod(30);
    doRun();
  }

  public void act()
  {
    // origin of x, y in center of window
    float[] a = sensor.getOrientation(3);
    Point p = new Point(
      (int)(-0.02 * a[5] * getNbVertCells()), // Roll
      (int)(0.02 * a[4] * getNbVertCells())); // Pitch
    p = reduce(p);
    bubble.setLocation(new Location(offset + p.x, offset + p.y));
  }

  private Point reduce(Point p)
  {
    // Reduce point to limiting circle
    if (p.x * p.x + p.y * p.y > rLimit * rLimit)
      return new Point(
        (int)(rLimit * p.x / Math.sqrt(p.x * p.x + p.y * p.y)),
        (int)(rLimit * p.y / Math.sqrt(p.x * p.x + p.y * p.y)));
    else
      return p;
  }

}
