// Launcher.java

package ch.aplu.tutparams;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.graphics.Color;
import android.widget.EditText;

public class Launcher extends Activity implements View.OnClickListener
{
  private EditText editHorz;
  private EditText editVert;

  public void onCreate(Bundle savedInstanceState)
  {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.launcher);
    editHorz = (EditText)findViewById(R.id.horzcells_edit);
    editVert = (EditText)findViewById(R.id.vertcells_edit);
    Button goButton = (Button)findViewById(R.id.go_btn);
    goButton.setOnClickListener(this);

    editHorz.setText("10");
    editHorz.setSelection(2);
    editVert.setText("10");
    editVert.setSelection(2);
  }

  public void onClick(View v)
  {
    String nbHorzCellsStr = editHorz.getText().toString().trim();
    String nbVertCellsStr = editVert.getText().toString().trim();

    Integer nbHorzCells = toInteger(nbHorzCellsStr);
    Integer nbVertCells = toInteger(nbVertCellsStr);
    if (nbHorzCells == null || nbHorzCells < 5 || nbHorzCells > 10
      || nbVertCells == null || nbVertCells < 6 || nbVertCells > 12)
    {

      AlertDialog alertDialog = new AlertDialog.Builder(this).create();
      alertDialog.setTitle("Illegal number of cells");
      alertDialog.setMessage("Again?");
      alertDialog.setButton("OK", new DialogInterface.OnClickListener()
      {
        public void onClick(DialogInterface dialog, int which)
        {
        }
      });
      alertDialog.show();
      return;
    }

    MyParams params = 
      new MyParams(nbHorzCells, nbVertCells, 0, Color.GREEN);
    params.setGameLevel(3);
    Intent intent = new Intent(this, MyGame.class);
    intent.putExtra("Params", params);
    startActivity(intent);
    finish();  
  }

  private Integer toInteger(String valueStr)
  {
    Integer value = null;
    try
    {
      value = new Integer(valueStr);
    }
    catch (NumberFormatException ex)
    {
      return null;
    }
    return value;
  }
}
